
				;PIC16F84A@8X5 MATRIX CLOCK	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;		Push B
;	RB0	ADJ SEC
;	RB1	ADJ MIN
;	RB2	ADJ HOUR
;
;		Pin No
;	RA0	16
;	RA1	15
;	RA2	11
;	RA3	6
;	RA7	10
;		4
;		3
;		13
;
;	
;	RB0	9
;	RB1	14
;	RB2	8
;	RB3	12
;	RB4	1
;	RB5	7
;	RB6	2
;	RB7	5
;
;	(TOM-1588BH-B)
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	list      p=16F84A	; |󎞂ɃXgt@C܂B	;;łǂPICgw肵܂B
	#include <p16F84A.inc>	; 16F84Ap`t@Cǂݍ݂܂B	;;
		
	;ASMt@Cł́u;vE͓ǂݎ܂̂ŒӏȂ藎\łB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
										@
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC	;4.194304MHz (_HS_OSC͊OɃNbNƂӖj
	;łB@ɂĂ낢茈߂͂܂A͗ɊoĂB 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	errorlevel  -302	; |󎞂302G[oȂ悤ɂ܂B							
	ORG	000H
	GOTO	INIT 

	ORG	004H
	GOTO	INT	
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;---- [` ----
INIT:
	
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;vÓuGOTOvȂǂ̖߂Ȃ艺։ւƍ~čs܂B
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	

	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ

	MOVLW	B'00000000'	;RA0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISA		;L̏TRISAiRÅǗj֊i[

	MOVLW	B'00000000'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[

	MOVLW   B'00000111'	;B'00000111'	;荞	1/256
	MOVWF	OPTION_REG

	BCF	STATUS,RP0	;BANK0ɐ؂ւ	STATUS,RP0OɂƂӖ

	BSF	INTCON,T0IE	;^C}
	BSF	INTCON,GIE	;S̊

	;PICɂ͐ݒ肷ӏBANK0BANK1ƂQӏ܂Bo͏BANK1ɂ܂̂STATUS,RP0ƂƂ
	;BANK1ɐ؂ւĐݒ芮BANK0ɖ߂܂B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	INPUT		EQU	PORTB
	S_ADJ		EQU	0	;bύX{^	
	M_ADJ		EQU	1	;ύX{^
	H_ADJ		EQU	2	;ύX{^
	OUTPUT_5	EQU	PORTA
	OUTPUT_8	EQU	PORTB	
	SPEED		EQU	D'1'	;x
	STEP		EQU	D'50'	;xi
	DUTY		EQU	D'150'	;f[eB[

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	COUNT_1		EQU	20H	;COUNTf[^1	s8
	COUNT_0		EQU	21H	;COUNTf[^0	s
	COUNT_X		EQU	22H	;COUNTf[^	
	COUNT_1S	EQU	23H	;COUNTf[^	b
	COUNT_10S	EQU	24H	;COUNTf[^	10b
	COUNT_1M	EQU	25H	;COUNTf[^	
	COUNT_10M	EQU	26H	;COUNTf[^	10
	COUNT_H		EQU	27H	;COUNTf[^	
	TIMER_1		EQU	28H	;TIMERf[^1	f[eB
	TIMING_0	EQU	29H	;TIMINGf[^0	x
	TIMING_1	EQU	2AH	;TIMINGf[^1	x
	TIMING_2	EQU	2BH	;TIMINGf[^2	xi
;			EQU	2CH	;
;			EQU	2DH	;
;			EQU	2EH	;
;			EQU	2FH	;
	DATA_1S_1	EQU	30H	;f[^ b1
	DATA_1S_2	EQU	31H	;f[^ b2
	DATA_1S_3	EQU	32H	;f[^ b3
	DATA_1S_4	EQU	33H	;f[^ b4
	DATA_10S_1	EQU	34H	;f[^ 10b1
	DATA_10S_2	EQU	35H	;f[^ 10b2
	DATA_10S_3	EQU	36H	;f[^ 10b3
	DATA_10S_4	EQU	37H	;f[^ 10b4
	DATA_1M_1	EQU	38H	;f[^ 1
	DATA_1M_2	EQU	39H	;f[^ 2
	DATA_1M_3	EQU	3AH	;f[^ 3
	DATA_1M_4	EQU	3BH	;f[^ 4
	DATA_10M_1	EQU	3CH	;f[^ 101
	DATA_10M_2	EQU	3DH	;f[^ 102
	DATA_10M_3	EQU	3EH	;f[^ 103
	DATA_10M_4	EQU	3FH	;f[^ 104
	DATA_H_1	EQU	40H	;f[^ 1
	DATA_H_2	EQU	41H	;f[^ 2
	DATA_H_3	EQU	42H	;f[^ 3
	DATA_H_4	EQU	43H	;f[^ 4
	DATA_H_5	EQU	44H	;f[^ 5
	DATA_H_6	EQU	45H	;f[^ 6
	DATA_H_7	EQU	46H	;f[^ 7
	DATA_H_8	EQU	47H	;f[^ 8
;			EQU	48H	;
;			EQU	49H	;
;			EQU	4AH	;
	W_TEMP		EQU 	4BH 	;WWX^Ҕ
	PCLATH_TEMP	EQU	4CH	;PCLATHҔ
	STATUS_TEMP	EQU	4DH	;STATUSҔ
	OVFL		EQU	4EH	;荞݃I[o[t[
 	FLAG		EQU	4FH	;etO
					;0	荞	
					;1	Psړ
					;2	S{^J
					;3	x
					;4	ADJ^C~Oi荞݁j
	
	MOVLW	D'0'
	MOVWF	DATA_1S_1
	MOVWF	DATA_1S_2
	MOVWF	DATA_1S_3
	MOVWF	DATA_1S_4
	MOVWF	DATA_10S_1
	MOVWF	DATA_10S_2
	MOVWF	DATA_10S_3
	MOVWF	DATA_10S_4
	MOVWF	DATA_1M_1
	MOVWF	DATA_1M_2
	MOVWF	DATA_1M_3
	MOVWF	DATA_1M_4
	MOVWF	DATA_10M_1
	MOVWF	DATA_10M_2
	MOVWF	DATA_10M_3
	MOVWF	DATA_10M_4
	MOVWF	DATA_H_1
	MOVWF	DATA_H_2
	MOVWF	DATA_H_3
	MOVWF	DATA_H_4
	MOVWF	DATA_H_5
	MOVWF	DATA_H_6
	MOVWF	DATA_H_7
	MOVWF	DATA_H_8

	MOVWF	OUTPUT_5
	MOVWF	OUTPUT_8

	MOVWF	COUNT_1
	MOVWF	COUNT_0
	MOVWF	COUNT_X
	MOVWF	COUNT_1S
	MOVWF	COUNT_10S
	MOVWF	COUNT_1M
	MOVWF	COUNT_10M
	MOVWF	COUNT_H

	MOVWF	FLAG

	MOVLW	SPEED
	MOVWF	TIMING_0		;x
	MOVWF	TIMING_1		;x

	MOVLW	STEP
	MOVWF	TIMING_2		;xi

	BSF	FLAG,0			;FLAG,0 ON
	MOVLW	D'16'			;
	MOVWF	OVFL			;荞݃I[o[t[

	GOTO	MAIN1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; ---- 荞݃[` ----

INT:
	MOVWF	W_TEMP			;WWX^Ҕ
	MOVF	STATUS,W		;STATUSo
	MOVWF	STATUS_TEMP		;STATUSҔ 
	MOVF	PCLATH,W		;PCLATHo
	MOVWF	PCLATH_TEMP		;PCLATHҔ 

	BCF	INTCON,T0IF		;TMR0I[o[t[tOOFF 
	BSF	FLAG,4			;FLAG,4 ON	ADJ^C~O

	DECFSZ	OVFL,F			;荞݃I[o[t[
	GOTO	INT_1

	MOVLW	D'16'			;
	MOVWF	OVFL			;荞݃I[o[t[
	BSF	FLAG,0			;FLAG,0 ON
 
INT_1
	MOVF	PCLATH_TEMP,W		;PCLATH߂
	MOVWF	PCLATH
	MOVF	STATUS_TEMP,W		;STATUS߂
	MOVWF	STATUS
	SWAPF	W_TEMP,F		;WWX^߂
	SWAPF	W_TEMP,W
	RETFIE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN1					;\
	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8

	CALL	ADJ			;ύX{^암
	CALL	PTN_2			;v

	MOVF	COUNT_0,W
	ADDWF	COUNT_1,F		;COUNT_0 + COUNT_1 = COUNT_1

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00000001'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە			
	INCF	COUNT_1,F		;COUNT_1+1=
	INCF	COUNT_1,F		;COUNT_1+1=
	INCF	COUNT_1,F		;COUNT_1+1=

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00000010'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F		;COUNT_1+1=
	INCF	COUNT_1,F		;COUNT_1+1=
	INCF	COUNT_1,F		;COUNT_1+1=

	
	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00000100'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F
	INCF	COUNT_1,F
	INCF	COUNT_1,F

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00001000'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F
	INCF	COUNT_1,F
	INCF	COUNT_1,F

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00010000'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F
	INCF	COUNT_1,F
	INCF	COUNT_1,F

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'00100000'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F
	INCF	COUNT_1,F
	INCF	COUNT_1,F

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'01000000'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	
	INCF	COUNT_1,F
	INCF	COUNT_1,F
	INCF	COUNT_1,F

	MOVLW	B'00011111'
	MOVWF	OUTPUT_5
	CLRF	OUTPUT_8
	MOVLW	B'10000000'
	MOVWF	OUTPUT_8
	CALL	PTN_1			;sǗ
	CALL	WAIT			;f[eBԊmە	

	CLRF	COUNT_1

	DECFSZ	TIMING_0,F
	GOTO	MAIN1
	BSF	FLAG,1			;FLAG,1 ON	;Psړ

	MOVF	COUNT_0,F		;s
	BTFSS	STATUS,Z		;COUNT_1=0?
	GOTO	MAIN1_3			;NO
					;YES
	BTFSC	FLAG,3			;FLAG,3 ON?	;x
	GOTO	MAIN1_2			;YES
					;NO
MAIN1_1

	INCF	TIMING_1,F		;TIMING_1+1=TIMING_1
	DECFSZ	TIMING_2		;xi
	GOTO	MAIN1_3

	BSF	FLAG,3			;FLAG,3 ON	;x
	MOVLW	STEP		
	MOVWF	TIMING_2		;xi

	GOTO	MAIN1_3

MAIN1_2	
	DECF	TIMING_1,F		;TIMING_1-1=TIMING_1
	DECFSZ	TIMING_2
	GOTO	MAIN1_3

	BCF	FLAG,3			;FLAG,3 ON	;x
	MOVLW	STEP		
	MOVWF	TIMING_2		;xi

	GOTO	MAIN1_3

MAIN1_3	
	MOVF	TIMING_1,W		;x	
	MOVWF	TIMING_0		;x

	GOTO	MAIN1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT					;f[eB[mە
	MOVLW	DUTY
	MOVWF	TIMER_1			;f[eB[

WAIT1
	NOP
	DECFSZ	TIMER_1,F		;f[eB[
	GOTO	WAIT1
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ADJ					;ύX{^암
	BTFSS	FLAG,4			;FLAG,4 ON?	ADJ^C~O 
	RETURN				;NO
					;YES
	BCF	FLAG,4			;FLAG,4 OFF

	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ
	MOVLW	B'00000111'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[
	BCF	STATUS,RP0	;BANK0ɐ؂ւ	STATUS,RP0OɂƂӖ

	BTFSC	INPUT,S_ADJ		;bύX{^
	GOTO	ADJ1			;NO	
					;YES
	BTFSS	FLAG,2			;FLAG,2	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES

	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ
	MOVLW	B'00000000'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[
	BCF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂ

	CALL	PTN_2_S			;f[^b
	GOTO	ADJ4
	
ADJ1	
	BTFSC	INPUT,M_ADJ		;ύX{^
	GOTO	ADJ2			;NO	
					;YES
	BTFSS	FLAG,2			;FLAG,2	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES
	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ
	MOVLW	B'00000000'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[
	BCF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂ

	CALL	PTN_2_M			;f[^
	GOTO	ADJ4
	
ADJ2	
	BTFSC	INPUT,H_ADJ		;ύX{^
	GOTO	ADJ3			;NO	
					;YES
	BTFSS	FLAG,2			;FLAG,2	ON?	;S{^J
	GOTO	ADJ5			;NO
					;YES
	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ
	MOVLW	B'00000000'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[
	BCF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂ

	CALL	PTN_2_H			;f[^
	GOTO	ADJ4
	
ADJ3
	BSF	FLAG,2			;FLAG,2	ON	;S{^J
	GOTO	ADJ5

ADJ4
	BCF	FLAG,2			;FLAG,2	OFF	;S{^J

ADJ5
	BSF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ
	MOVLW	B'00000000'	;RB0`7ׂďo	i1͓́A 0o͂̈Ӗj
	MOVWF	TRISB		;L̏TRISBiRB̊Ǘj֊i[
	BCF	STATUS,RP0	;BANK1ɐ؂ւ	STATUS,RP0PɂƂӖ

	RETURN
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PTN_1					;sǗ
	BTFSS	FLAG,1			;FLAG,1 ON?	;Psړ
	GOTO	PTN_1_1			;NO
					;YES	
	BCF	FLAG,1			;FLAG,1 OFF
	INCF	COUNT_0,F		;COUNT_0+1=
	INCF	COUNT_0,F		;COUNT_0+1=
	INCF	COUNT_0,F		;COUNT_0+1=
	MOVF	COUNT_0,W
	MOVWF	COUNT_1			;COUNT_0  COUNT_1@

	MOVLW	D'123'			;	;s	
	SUBWF	COUNT_1,W
	BTFSS	STATUS,C		;COUNT_0-99=0?
	GOTO	PTN_1_1			;NO
					;YES
	CLRF	COUNT_1
	CLRF	COUNT_0

PTN_1_1					;Sf[^Ǘ
	CALL	MAIN_TABLE
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PTN_2					;v
	BTFSS	FLAG,0			;FLAG,0 ON?	;荞 
	RETURN				;NO
					;YES
	BCF	FLAG,0			;FLAG,0 OFF

PTN_2_S
	INCF	COUNT_1S		;COUNTf[^b
	MOVLW	D'10'
	SUBWF	COUNT_1S,W
	BTFSS	STATUS,C		;COUNT_1S-10=0?
	GOTO	PTN_2_1			;NO
	CLRF	COUNT_1S		;YES

	INCF	COUNT_10S		;COUNTf[^10b
	MOVLW	D'6'
	SUBWF	COUNT_10S,W
	BTFSS	STATUS,C		;COUNT_10S-6=0?
	GOTO	PTN_2_1			;NO
	CLRF	COUNT_10S		;YES

PTN_2_M
	INCF	COUNT_1M		;COUNTf[^
	MOVLW	D'10'
	SUBWF	COUNT_1M,W
	BTFSS	STATUS,C		;COUNT_1M-10=0?
	GOTO	PTN_2_1			;NO
	CLRF	COUNT_1M		;YES

	INCF	COUNT_10M		;COUNTf[^10
	MOVLW	D'6'
	SUBWF	COUNT_10M,W
	BTFSS	STATUS,C		;COUNT_10M-6=0?
	GOTO	PTN_2_1			;NO
	CLRF	COUNT_10M		;YES

PTN_2_H	
	INCF	COUNT_H			;COUNTf[^
	MOVLW	D'12'
	SUBWF	COUNT_H,W
	BTFSS	STATUS,C		;COUNT_H-12=0?
	GOTO	PTN_2_1			;NO
	CLRF	COUNT_H			;YES

PTN_2_1					;e[^i[
	MOVF	COUNT_1S,W		;COUNTf[^b	
	MOVWF	COUNT_X			;COUNT_X ֑
	CALL	PTN_TABLE1_1
	MOVWF	DATA_1S_1
	CALL	PTN_TABLE1_2
	MOVWF	DATA_1S_2
	CALL	PTN_TABLE1_3
	MOVWF	DATA_1S_3
	CALL	PTN_TABLE1_4
	MOVWF	DATA_1S_4

	MOVF	COUNT_10S,W		;COUNTf[^10b
	MOVWF	COUNT_X			;COUNT_X ֑
	CALL	PTN_TABLE1_1
	MOVWF	DATA_10S_1
	CALL	PTN_TABLE1_2
	MOVWF	DATA_10S_2
	CALL	PTN_TABLE1_3
	MOVWF	DATA_10S_3
	CALL	PTN_TABLE1_4
	MOVWF	DATA_10S_4

	MOVF	COUNT_1M,W		;COUNTf[^	
	MOVWF	COUNT_X			;COUNT_X ֑
	CALL	PTN_TABLE1_1
	MOVWF	DATA_1M_1
	CALL	PTN_TABLE1_2
	MOVWF	DATA_1M_2
	CALL	PTN_TABLE1_3
	MOVWF	DATA_1M_3
	CALL	PTN_TABLE1_4
	MOVWF	DATA_1M_4

	MOVF	COUNT_10M,W		;COUNTf[^10
	MOVWF	COUNT_X			;COUNT_X ֑
	CALL	PTN_TABLE1_1
	MOVWF	DATA_10M_1
	CALL	PTN_TABLE1_2
	MOVWF	DATA_10M_2
	CALL	PTN_TABLE1_3
	MOVWF	DATA_10M_3
	CALL	PTN_TABLE1_4
	MOVWF	DATA_10M_4

	MOVF	COUNT_H,W		;COUNTf[^
	MOVWF	COUNT_X			;COUNT_X ֑
	CALL	PTN_TABLE1_1H
	MOVWF	DATA_H_1
	CALL	PTN_TABLE1_2H
	MOVWF	DATA_H_2
	CALL	PTN_TABLE1_3H
	MOVWF	DATA_H_3
	CALL	PTN_TABLE1_4H
	MOVWF	DATA_H_4
	CALL	PTN_TABLE1_5H
	MOVWF	DATA_H_5
	CALL	PTN_TABLE1_6H
	MOVWF	DATA_H_6
	CALL	PTN_TABLE1_7H
	MOVWF	DATA_H_7
	CALL	PTN_TABLE1_8H
	MOVWF	DATA_H_8

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	200H 

PTN_TABLE1_1
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00000000'		;0
	RETLW	B'00011111'		;1
	RETLW	B'00000010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011000'		;4
	RETLW	B'00001000'		;5
	RETLW	B'00000000'		;6
	RETLW	B'00011110'		;7
	RETLW	B'00000000'		;8
	RETLW	B'00001000'		;9

PTN_TABLE1_2
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001110'		;0
	RETLW	B'00001110'		;1
	RETLW	B'00001010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011011'		;4
	RETLW	B'00001010'		;5
	RETLW	B'00001010'		;6
	RETLW	B'00000110'		;7
	RETLW	B'00001010'		;8
	RETLW	B'00001010'		;9

PTN_TABLE1_3
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001110'		;0
	RETLW	B'00000000'		;1
	RETLW	B'00001010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011011'		;4
	RETLW	B'00001010'		;5
	RETLW	B'00001010'		;6
	RETLW	B'00011010'		;7
	RETLW	B'00001010'		;8
	RETLW	B'00001010'		;9

PTN_TABLE1_4
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00000000'		;0
	RETLW	B'00001111'		;1
	RETLW	B'00001000'		;2
	RETLW	B'00000000'		;3
	RETLW	B'00000000'		;4
	RETLW	B'00000010'		;5
	RETLW	B'00000010'		;6
	RETLW	B'00011100'		;7
	RETLW	B'00000000'		;8
	RETLW	B'00000000'		;9

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PTN_TABLE1_1H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001110'		;12
	RETLW	B'00011111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00011111'		;7
	RETLW	B'00011111'		;8
	RETLW	B'00011111'		;9
	RETLW	B'00001110'		;10
	RETLW	B'00001110'		;11
	RETLW	B'00011111'		;0

PTN_TABLE1_2H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00000000'		;12
	RETLW	B'00011111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00011111'		;7
	RETLW	B'00011111'		;8
	RETLW	B'00011111'		;9
	RETLW	B'00000000'		;10
	RETLW	B'00000000'		;11
	RETLW	B'00011111'		;0

PTN_TABLE1_3H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001111'		;12
	RETLW	B'00011111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00011111'		;7
	RETLW	B'00011111'		;8
	RETLW	B'00011111'		;9
	RETLW	B'00001111'		;10
	RETLW	B'00001111'		;11
	RETLW	B'00011111'		;0

PTN_TABLE1_4H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00011111'		;12
	RETLW	B'00011111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00011111'		;7
	RETLW	B'00011111'		;8
	RETLW	B'00011111'		;9
	RETLW	B'00011111'		;10
	RETLW	B'00011111'		;11
	RETLW	B'00011111'		;0

PTN_TABLE1_5H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00000010'		;12
	RETLW	B'00011111'		;1
	RETLW	B'00000010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011000'		;4
	RETLW	B'00001000'		;5
	RETLW	B'00000000'		;6
	RETLW	B'00011110'		;7
	RETLW	B'00000000'		;8
	RETLW	B'00001000'		;9
	RETLW	B'00000000'		;10
	RETLW	B'00011111'		;11
	RETLW	B'00000000'		;0

PTN_TABLE1_6H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001010'		;12
	RETLW	B'00001110'		;1
	RETLW	B'00001010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011011'		;4
	RETLW	B'00001010'		;5
	RETLW	B'00001010'		;6
	RETLW	B'00000110'		;7
	RETLW	B'00001010'		;8
	RETLW	B'00001010'		;9
	RETLW	B'00001110'		;10
	RETLW	B'00001110'		;11
	RETLW	B'00001110'		;0

PTN_TABLE1_7H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001010'		;12
	RETLW	B'00000000'		;1
	RETLW	B'00001010'		;2
	RETLW	B'00001010'		;3
	RETLW	B'00011011'		;4
	RETLW	B'00001010'		;5
	RETLW	B'00001010'		;6
	RETLW	B'00011010'		;7
	RETLW	B'00001010'		;8
	RETLW	B'00001010'		;9
	RETLW	B'00001110'		;10
	RETLW	B'00000000'		;11
	RETLW	B'00001110'		;0

PTN_TABLE1_8H
	MOVLW	H'02'
	MOVWF	PCLATH	; e[u 0x200`0x2FFԒnɑ

	MOVF	COUNT_X,W
	ADDWF	PCL,F

	RETLW	B'00001000'		;12
	RETLW	B'00001111'		;1
	RETLW	B'00001000'		;2
	RETLW	B'00000000'		;3
	RETLW	B'00000000'		;4
	RETLW	B'00000010'		;5
	RETLW	B'00000010'		;6
	RETLW	B'00011100'		;7
	RETLW	B'00000000'		;8
	RETLW	B'00000000'		;9
	RETLW	B'00000000'		;10
	RETLW	B'00001111'		;11
	RETLW	B'00000000'		;0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	300H 

MAIN_TABLE
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ

	MOVF	COUNT_1,W
	ADDWF	PCL,F

	MOVLW	B'00011111'		;1
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;2
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;3
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;4
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;5
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;6
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;7
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;8
	MOVWF	OUTPUT_5
	RETURN

	MOVF	DATA_H_1,W		;HOUR 1
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_2,W		;HOUR 2
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_3,W		;HOUR 3
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_4,W		;HOUR 4
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_5,W		;HOUR 5
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_6,W		;HOUR 6
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_7,W		;HOUR 7
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_H_8,W		;HOUR 8
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00010101'		; :
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN

	MOVF	DATA_10M_1,W		;MIN x10 1
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10M_2,W		;MIN x10 2
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10M_3,W		;MIN x10 3
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10M_4,W		;MIN x10 4
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN

	MOVF	DATA_1M_1,W		;MIN x1 1
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1M_2,W		;MIN x1 2
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1M_3,W		;MIN x1 3
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1M_4,W		;MIN x1 4
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00010101'		; :
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN

	MOVF	DATA_10S_1,W		;SEC x10 1
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10S_2,W		;SEC x10 2
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10S_3,W		;SEC x10 3
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_10S_4,W		;SEC x10 4
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;
	MOVWF	OUTPUT_5
	RETURN

	MOVF	DATA_1S_1,W		;SEC x1 1
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1S_2,W		;SEC x1 2
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1S_3,W		;SEC x1 3
	MOVWF	OUTPUT_5
	RETURN
	MOVF	DATA_1S_4,W		;SEC x1 4
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;1
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;2
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;3
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;4
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;5
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;6
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;7
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;8
	MOVWF	OUTPUT_5
	RETURN

	MOVLW	B'00011111'		;1
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;2
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;3
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;4
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;5
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;6
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;7
	MOVWF	OUTPUT_5
	RETURN
	MOVLW	B'00011111'		;8
	MOVWF	OUTPUT_5
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 	END
